window.onload = init;

let canvas, ctx;
let monstre, monstre2, pacman1;
let audioCtx, osc1, lfo;
let tableauPacmen = [];

function init() {
  canvas = document.querySelector("#myCanvas");
  ctx = canvas.getContext("2d");
  
  initSound();

  monstre = new Monstre(100, 100, "red");
  monstre2 = new Monstre(200, 200, "Blue");
  monstre2.vitesseX = 1;
  monstre2.vitesseY = 5;

  pacman1 = new Pacman(100, 100, "yellow");
  pacman1.vitesseX = 1;

  creerDesPacmen(20);

  // on demande d'exécuter la fonction anime()
  // dans 1/60ème de seconde
  requestAnimationFrame(anime);
  
  // animations secondaires
  //setInterval(changeCouleurMonstre, 500); // 1000 MS
  
  definitEcouteursClavier();
}

function creerDesPacmen(n) {
    tableauPacmen = [];

    let tabCouleurs = ["red", "yellow", "lightgreen", "purple", "orange"];

    for(let i=0; i < n; i++) {
        let x = Math.random()*canvas.width;
        let y = Math.random()*canvas.height;
        let couleur = tabCouleurs[Math.round(Math.random()*tabCouleurs.length)];
        let vx = -10 + Math.random()*20; // entre -10 et +10
        let vy = -10 + Math.random()*20;
        
        let p = new Pacman(x, y, couleur);
        p.vitesseX = vx;
        p.vitesseY = vy;

        // ajout au tableau
        tableauPacmen.push(p);
    }
}

function dessinerLesPacmen(ctx) {
    tableauPacmen.forEach((p) => {
        p.draw(ctx);
    });
}

function deplacerLesPacmen() {
    tableauPacmen.forEach((p) => {
        p.move();
    });
}

function testerCollisionsMurPacmen() {
    tableauPacmen.forEach((p) => {
        testeCollisionsAvecMurs(p);
    });
}
function testerCollisionsJoueurPacmen() {
    tableauPacmen.forEach((p, index) => {
        if(circRectsOverlap(monstre.x, monstre.y, monstre.l, monstre.h,
            p.x, p.y, p.r)) {
                // on supprime le pacman du tableau
                let nbElementsASupprimer = 1;
                tableauPacmen.splice(index, nbElementsASupprimer);
            }
    });
}

function changeCouleurMonstre() {
  if(monstre.couleur === "red") {
    monstre.couleur = "lightGreen";
  } else {
    monstre.couleur = "red";
  }
}

function anime() {
  // 1 - on efface le contenu du canvas
  ctx.clearRect(0, 0, canvas.width,canvas.height);
  
  // 2 - on dessine 
  dessinerLesPacmen(ctx);

  monstre.draw(ctx);
  monstre2.draw(ctx);

  // 3 on regarde l'état du clavier, de la souris,
  // du jeu, de la manette etc.
  // et on déplace les objets
  monstre.move();
  monstre2.move();
  
  deplacerLesPacmen();

  // pour le son émis par monstre2
  changeAudioFreq(monstre2.y);
  changeAudioFMFreq(monstre2.y/20);

  // 4 - on teste les collisions, les ennemis morts...
  testeCollisionsAvecMurs(monstre);
  testeCollisionsAvecMurs(monstre2);

  testerCollisionsMurPacmen();

  testerCollisionsJoueurPacmen();
  
  // 5 - on demande encore une nouvelle image dans 1/60ème de seconde
  requestAnimationFrame(anime);
}

